[![CI](https://github.com/michaelfliegner/BitemporalPostgres.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/michaelfliegner/BitemporalPostgres.jl/actions/workflows/CI.yml)

[![Documentation](https://github.com/michaelfliegner/BitemporalPostgres.jl/actions/workflows/Documentation.yml/badge.svg)](https://github.com/michaelfliegner/BitemporalPostgres.jl/actions/workflows/Documentation.yml)

[![pages-build-deployment](https://github.com/michaelfliegner/BitemporalPostgres.jl/actions/workflows/pages/pages-build-deployment/badge.svg)](https://github.com/michaelfliegner/BitemporalPostgres.jl/actions/workflows/pages/pages-build-deployment)

# BitemporalPostgres provides an API for application based bitemporal transactions with Julia and Postgres DB. Transactions are "long", with persistent transaction data that is, so they can serve as a basis of workflow management: they can be suspended, resumed and delegated.

Documentation
[here](https://michaelfliegner.github.io/BitemporalPostgres.jl/dev/)

A web app using this module for persistence will be built at https://github.com/michaelfliegner/BitempWebApp.jl


## This project is a [Julia](https://julialang.org/) template configured for ephemeral development environments on [Gitpod](https://www.gitpod.io/). 
If You start this repo in [gitpod](https://www.gitpod.io/docs/), You can open [this jupyter notebook](./bitemporal_testcase.ipynb) in vscode and execute the included code snippets with julia and postgres up and running.

## Next Steps

Click the button below to start a new development environment:

[![Open in Gitpod](https://gitpod.io/button/open-in-gitpod.svg)](https://gitpod.io/#https://github.com/gitpod-io/template-julia)

## Get Started With Your Own Project

### A new project

Click the above "Open in Gitpod" button to start a new workspace. Once you're ready to push your first code changes, Gitpod will guide you to fork this project so you own it.
